#pragma once

#include <stdint.h>
#include "../utils/int_least.hpp"

namespace Devices
{
    template<class SerialInT, class SerialClkT, class LoadT, uint8_t N>
    class Ttl74165
    {
        public:

            using DataT = Utils::UIntLeast<N*8>;

            static void Init()
            {
                SerialInT::ConfigureAsInput(false);
                SerialClkT::ConfigureAsOutput();
                SerialClkT::SetLow();
                LoadT::ConfigureAsOutput();
                LoadT::SetHigh();
            }

            static void Out(DataT const data)
            {
            }

            static DataT In()
            {
                DataT data = 0;

                LoadT::SetLow();
                LoadT::SetHigh();

                for (uint8_t i = 0; i < N * 8; ++i)
                {
                    data <<= 1;

                    if (SerialInT::Get())
                    {
                        data |= 1;
                    }

                    SerialClkT::SetHigh();
                    SerialClkT::SetLow();
                }

                return data;
            }
    };
}
